//************************************************************************************************************************
//***			CREST DLL
//************************************************************************************************************************

class CrestDLLClass
{
private:
public:
	CrestDLLClass();
	virtual ~CrestDLLClass();
	virtual int LoadConfigFiles();
	virtual int Initialize();
	virtual int InitializeCuda();
	virtual int GetNum();
	virtual void SetNum(int);
	virtual bool GrabImage(int **tmp[2], unsigned char ***rgb, unsigned short **depth_map, unsigned short **depth_map_original, unsigned char **image_rectified);
	virtual bool Process();
	virtual bool GetCurrentOutputImage(unsigned char ***rgb);
	virtual bool GetCurrentTrackingImage(unsigned char ***rgb, int depth_min, int depth_max, int xmin, int xmax);
	virtual int GetNumMessages();
	virtual void GetMessage(char *msg, int num_message);
	virtual int GetNumTrackingMessages();
	virtual void GetTrackingMessage(char *msg, int num_message);
	virtual void GetWorldCoordinate(float *world_coordinate, float resolution);
	virtual int GetCurrentFrameNumber();
	virtual void GetTrackInformation(int *x, int *y, float *X, float *Y, float *Z, int *ID, const int iMaxSize, int &iFoundObjects);
};


typedef void (CrestDLLClass::*PfnConstructorOfCrestDLLClass)();
typedef void (CrestDLLClass::*PfnDestructorOfCrestDLLClass)();
typedef int (CrestDLLClass::*PfnLoadConfigFilesOfCrestDLLClass)();
typedef int (CrestDLLClass::*PfnInitializeOfCrestDLLClass)();
typedef int (CrestDLLClass::*PfnInitializeCudaOfCrestDLLClass)();
typedef void (CrestDLLClass::*PfnSetNumOfCrestDLLClass)(int);
typedef int	 (CrestDLLClass::*PfnGetNumOfCrestDLLClass)();
typedef bool (CrestDLLClass::*PfnGrabImageOfCrestDLLClass)(int **tmp[2], unsigned char ***rgb, unsigned short **depth_map, unsigned short **depth_map_original, unsigned char **image_rectified);
typedef bool (CrestDLLClass::*PfnProcessOfCrestDLLClass)();
typedef bool (CrestDLLClass::*PfnGetCurrentOutputImageOfCrestDLLClass)(unsigned char ***rgb);
typedef bool (CrestDLLClass::*PfnGetCurrentTrackingImageOfCrestDLLClass)(unsigned char ***rgb, int depth_min, int depth_max, int xmin, int xmax);
typedef int (CrestDLLClass::*PfnGetNumMessagesOfCrestDLLClass)();
typedef void (CrestDLLClass::*PfnGetMessageOfCrestDLLClass)(char *msg, int num_message);
typedef int (CrestDLLClass::*PfnGetNumTrackingMessagesOfCrestDLLClass)();
typedef void (CrestDLLClass::*PfnGetTrackingMessageOfCrestDLLClass)(char *msg, int num_message);
typedef void (CrestDLLClass::*PfnGetWorldCoordinateOfCrestDLLClass)(float *msg, float resolution);
typedef int (CrestDLLClass::*PfnGetCurrentFrameNumberOfCrestDLLClass)();
typedef void (CrestDLLClass::*PfnGetTrackInformationOfCrestDLLClass)(int *x, int *y, float *X, float *Y, float *Z, int *ID, const int iMaxSize, int &iFoundObjects);

CrestDLLClass::CrestDLLClass()
{
	static PfnConstructorOfCrestDLLClass pfnConsCrestDLLClass = force_cast<PfnConstructorOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "ConstructorOfCrestDLLClass"));

	(this->*pfnConsCrestDLLClass)();
}

int CrestDLLClass::LoadConfigFiles()
{
	static PfnLoadConfigFilesOfCrestDLLClass pfnLoadConfigFilesCrestDLLClass = force_cast<PfnLoadConfigFilesOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "LoadConfigFilesOfCrestDLLClass"));

	return (this->*pfnLoadConfigFilesCrestDLLClass)();
}

int CrestDLLClass::Initialize()
{
	static PfnInitializeOfCrestDLLClass pfnInitializeCrestDLLClass = force_cast<PfnInitializeOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "InitializeOfCrestDLLClass"));

	return (this->*pfnInitializeCrestDLLClass)();
}

int CrestDLLClass::InitializeCuda()
{
	static PfnInitializeCudaOfCrestDLLClass pfnInitializeCudaCrestDLLClass = force_cast<PfnInitializeCudaOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "InitializeCudaOfCrestDLLClass"));

	return (this->*pfnInitializeCudaCrestDLLClass)();
}

void CrestDLLClass::SetNum(int n)
{
	static PfnSetNumOfCrestDLLClass pfnSetNumCrestDLLClass = force_cast<PfnSetNumOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "SetNumOfCrestDLLClass"));

	(this->*pfnSetNumCrestDLLClass)(n);
}

int CrestDLLClass::GetNum()
{
	static PfnGetNumOfCrestDLLClass pfnGetNumCrestDLLClass = force_cast<PfnGetNumOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetNumOfCrestDLLClass"));

	return (this->*pfnGetNumCrestDLLClass)();
}

bool CrestDLLClass::GrabImage(int **tmp[2], unsigned char ***rgb, unsigned short **depth_map, unsigned short **depth_map_original, unsigned char **image_rectified)
{
	static PfnGrabImageOfCrestDLLClass pfnGrabImageCrestDLLClass = force_cast<PfnGrabImageOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GrabImageOfCrestDLLClass"));

	return (this->*pfnGrabImageCrestDLLClass)(tmp, rgb, depth_map, depth_map_original, image_rectified);
}

bool CrestDLLClass::Process()
{
	static PfnProcessOfCrestDLLClass pfnProcessCrestDLLClass = force_cast<PfnProcessOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "ProcessOfCrestDLLClass"));

	return (this->*pfnProcessCrestDLLClass)();
}

bool CrestDLLClass::GetCurrentOutputImage(unsigned char ***rgb)
{
	static PfnGetCurrentOutputImageOfCrestDLLClass pfnGetCurrentOutputImageCrestDLLClass = force_cast<PfnGetCurrentOutputImageOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetCurrentOutputImageOfCrestDLLClass"));

	return (this->*pfnGetCurrentOutputImageCrestDLLClass)(rgb);
}

bool CrestDLLClass::GetCurrentTrackingImage(unsigned char ***rgb, int depth_min, int depth_max, int xmin, int xmax)
{
	static PfnGetCurrentTrackingImageOfCrestDLLClass pfnGetCurrentTrackingImageCrestDLLClass = force_cast<PfnGetCurrentTrackingImageOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetCurrentTrackingImageOfCrestDLLClass"));

	return (this->*pfnGetCurrentTrackingImageCrestDLLClass)(rgb, depth_min, depth_max, xmin, xmax);
}

int CrestDLLClass::GetNumMessages()
{
	static PfnGetNumMessagesOfCrestDLLClass pfnGetNumMessagesCrestDLLClass = force_cast<PfnGetNumMessagesOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetNumMessagesOfCrestDLLClass"));

	return (this->*pfnGetNumMessagesCrestDLLClass)();
}

void CrestDLLClass::GetMessage(char *msg, int num_message)
{
	static PfnGetMessageOfCrestDLLClass pfnGetMessageCrestDLLClass = force_cast<PfnGetMessageOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetMessageOfCrestDLLClass"));

	(this->*pfnGetMessageCrestDLLClass)(msg, num_message);
}

int CrestDLLClass::GetNumTrackingMessages()
{
	static PfnGetNumTrackingMessagesOfCrestDLLClass pfnGetNumTrackingMessagesCrestDLLClass = force_cast<PfnGetNumTrackingMessagesOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetNumTrackingMessagesOfCrestDLLClass"));

	return (this->*pfnGetNumTrackingMessagesCrestDLLClass)();
}

void CrestDLLClass::GetTrackingMessage(char *msg, int num_message)
{
	static PfnGetTrackingMessageOfCrestDLLClass pfnGetTrackingMessageCrestDLLClass = force_cast<PfnGetTrackingMessageOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetTrackingMessageOfCrestDLLClass"));

	(this->*pfnGetTrackingMessageCrestDLLClass)(msg, num_message);
}

void CrestDLLClass::GetWorldCoordinate(float *world_coordinate, float resolution)
{
	static PfnGetWorldCoordinateOfCrestDLLClass pfnGetWorldCoordinateCrestDLLClass = force_cast<PfnGetWorldCoordinateOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetWorldCoordinateOfCrestDLLClass"));

	(this->*pfnGetWorldCoordinateCrestDLLClass)(world_coordinate, resolution);
}

int CrestDLLClass::GetCurrentFrameNumber()
{
	static PfnGetCurrentFrameNumberOfCrestDLLClass pfnGetCurrentFrameNumberCrestDLLClass = force_cast<PfnGetCurrentFrameNumberOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetCurrentFrameNumberOfCrestDLLClass"));

	return (this->*pfnGetCurrentFrameNumberCrestDLLClass)();
}

void CrestDLLClass::GetTrackInformation(int *x, int *y, float *X, float *Y, float *Z, int *ID, const int iMaxSize, int &iFoundObjects)
{
	static PfnGetTrackInformationOfCrestDLLClass pfnGetTrackInformationCrestDLLClass = force_cast<PfnGetTrackInformationOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "GetTrackInformationOfCrestDLLClass"));

	return (this->*pfnGetTrackInformationCrestDLLClass)(x, y, X, Y, Z, ID, iMaxSize, iFoundObjects);
}


CrestDLLClass::~CrestDLLClass()
{
	static PfnDestructorOfCrestDLLClass pfnDestCrestDLLClass = force_cast<PfnDestructorOfCrestDLLClass>(GetProcAddress(ClassLoader<CrestDLLClass>::s_hMod, "ConstructorOfCrestDLLClass"));

	(this->*pfnDestCrestDLLClass)();
}


//************************************************************************************************************************
//************************************************************************************************************************
//************************************************************************************************************************



/** Example of DLL interface
*/
class CrestDLLClassInterface
{
public:
	////*******************************************
	HINSTANCE hMod;

	typedef CrestDLLClass* (*PFNCreateCrestDLLClass)();
	PFNCreateCrestDLLClass pfnCreateCrestDLLClass;
	CrestDLLClass* _crestdllclass;

	/** Load the CrestDLL, intialize the memory and load the configuration files
	*/
	void LoadDLLandConfig( )	{

		hMod = NULL;
		hMod = LoadLibrary(TEXT("crest_program.dll"));
		if (hMod == NULL)
			ErrorExit(TEXT("LoadLibrary"));

		pfnCreateCrestDLLClass = (PFNCreateCrestDLLClass)GetProcAddress(hMod, "CreateObjectofCrestDLLClass");

		_crestdllclass = (pfnCreateCrestDLLClass)();

		return _crestdllclass->LoadConfigFiles();
	}
};